$(function() {
    $('.file-upload-widget').each(function() {
        var base_widget = $(this);
        if ($(base_widget).find('input[type=hidden]').val()) {
            $(base_widget).find('input[type=file]').hide();
            $(base_widget).find('.use-file-from-fargo').hide();
        } else {
            $(base_widget).find('.fileinfo').hide();
        }
        function disable() {
            base_widget.find('.subwidget input').prop('disabled', true);
            $('form').on('submit', function () {
                $('input').prop('disabled', false);
            });
        }
        function enable() {
            if (base_widget.find('.subwidget input:disabled').length) {
                base_widget.find('.subwidget input').val('');
                base_widget.find('.subwidget input').prop('disabled', false);
            }
        }
        $(this).find('input[type=file]').fileupload({
            dataType: 'json',
            add: function (e, data) {
                $(base_widget).find('.fileprogress .bar').css('width', '0%');
                $(base_widget).find('.fileprogress').show();
                $(base_widget).find('.fileinfo').hide();
                $(base_widget).parents('form').find('input[name=submit]').prop('disabled', true);
                var jqXHR = data.submit();
            },
            done: function(e, data) {
                $(base_widget).find('.fileprogress').hide();
                $(base_widget).find('.filename').text(data.result[0].name);
                $(base_widget).find('.fileinfo').show();
                $(base_widget).find('input[name$="$token"]').val(data.result[0].token);
                $(base_widget).find('select[name$="$validation_url"]').val('');
                enable();
                $(base_widget).parents('form').find('input[name=submit]').prop('disabled', false);
                $(this).hide();
                $(base_widget).find('.use-file-from-fargo').hide();
            },
            progress: function (e, data) {
                var progress = parseInt(data.loaded / data.total * 100, 10);
                $(base_widget).find('.fileprogress .bar').css('width', progress + '%');
            }
        });
        $(this).find('a.remove').click(function() {
            $(base_widget).find('input[name$="$token"]').val('');
            $(base_widget).find('.fileinfo').hide();
            $(base_widget).find('input[type=file]').show();
            $(base_widget).find('.use-file-from-fargo').show();
            return false;
        });
        $(this).find('a.change').click(function() {
            $(base_widget).find('input[type=file]').click();
            return false;
        });
        if ($(this).find('select[name$="$validation_url"] option:selected').val()) {
            disable();
        }
        $(this).find('select[name$="$validation_url"]').on('change', function() {
            var url = $(this).find(':selected').val();
            if (url) {
                var validations = $(this).data('validations');

                for (var i = 0; i < validations.length; i++) {
                    if (validations[i].url == url) {
                        base_widget.find('a.remove').trigger('click');
                        for (var item in validations[i]) {
                            if (! item) {
                                continue;
                            }
                            var $input = base_widget.find('input[name$="$' + item + '"]');
                            if ($input.length) {
                                $input.val(validations[i][item]);
                            }
                        }
                        disable();
                    }
                }
            } else {
                enable();
            }
        });
    });
});
